part of ncmb;

class NCMBObject {
  String _name;
  Map _fields = {};
  NCMB _ncmb;
  
  NCMBObject(this._ncmb, this._name);
  
  void set(String name, Object value) {
    if (name == 'createDate' || name == 'updateDate') {
      value = DateTime.parse(value);
    }
    if (name == 'acl') {
      if (!(value is NCMBAcl)) {
        var acl = new NCMBAcl();
        acl.sets(value);
        value = acl;
      }
    }
    _fields[name] = value;
  }
  
  void sets(Map map) {
    map.forEach((k, v) => set(k, v));
  }
  
  Future<void> save() async {
    if (!_fields.containsKey('objectId')) {
      NCMBRequest r = new NCMBRequest(_ncmb);
      Map response = await r.post(_name, _fields);
      response.forEach((key, value) => set(key, value));
    } else {
      NCMBRequest r = new NCMBRequest(_ncmb);
      Map response = await r.put(_name, _fields['objectId'], _fields);
      response.forEach((key, value) => set(key, value));
    }
    return true;
  }
  
  Future<void> destroy() async {
    if (!_fields.containsKey('objectId')) {
      throw Exception('objectId is not found.');
    }
    NCMBRequest r = new NCMBRequest(_ncmb);
    await r.delete(_name, _fields['objectId']);
  }
  
  Object get(String name) {
    return _fields[name];
  }
  
  dynamic toJson() {
    return {
      '__type':'Pointer',
      'className':_name,
      'objectId': _fields['objectId']
    };
  }
}
